"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const oaf_routing_1 = require("oaf-routing");
exports.defaultSettings = Object.assign({}, oaf_routing_1.defaultSettings, { 
    // TODO support pop page state restoration.
    restorePageStateOnPop: false, 
    // We're not restoring page state ourselves so leave this enabled.
    disableAutoScrollRestoration: false });
exports.wrapRouter = (router, 
// HACK instanceof doesn't work across require() boundary
isNavigationEndEvent, settingsOverrides) => {
    const settings = Object.assign({}, exports.defaultSettings, settingsOverrides);
    const oafRouter = oaf_routing_1.createOafRouter(settings, navigation => {
        const fragment = (navigation.finalUrl || navigation.extractedUrl).fragment;
        return fragment !== null ? `#${fragment}` : "";
    });
    const subscription = router.events.subscribe(event => {
        if (isNavigationEndEvent(event)) {
            const navigation = router.getCurrentNavigation();
            if (navigation !== null) {
                if (navigation.previousNavigation === null) {
                    oafRouter.handleFirstPageLoad(navigation);
                }
                else {
                    oafRouter.handleLocationChanged(navigation.previousNavigation, navigation, undefined, undefined);
                }
            }
        }
    });
    return () => {
        oafRouter.resetAutoScrollRestoration();
        subscription.unsubscribe();
    };
};
